<?php

namespace Intergo\LaravelAuthMiddleware\Traits;

use Illuminate\Http\JsonResponse;

trait ResponseTrait
{
    /**
     * @param array $data
     * @return JsonResponse
     */
    private function success(array $data = []): JsonResponse
    {
        return $this->response(true, '', $data);
    }

    /**
     * @param string $message
     * @param array $data
     * @return JsonResponse
     */
    private function failed(string $message = 'Unauthorized', array $data = []): JsonResponse
    {
        return $this->response(false, $message, $data, 401);
    }

    /**
     * @param bool $success
     * @param string $message
     * @param array $data
     * @param int $status
     * @return JsonResponse
     */
    private function response(bool $success = true, string $message = '', array $data = [], int $status = 200): JsonResponse
    {
        return response()->json(compact('success', 'message', 'data'), $status);
    }
}
